/* SMBooster configuration program
 */

/*  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

# include <mintbind.h>
# include <gemma/gemma.h>

# include "smconfig.h"

static inline void
deselect(WINDIAL *wd, short obj)
{
	OBJECT *ob = wd->wb_treeptr;

	if ((!(ob[obj].ob_state & OS_WHITEBAK) && !(ob[obj].ob_flags & OF_RBUTTON)))
		objc_xchange(wd, obj, ob[obj].ob_state & ~OS_SELECTED, 1);
}

long
newkey(WINDIAL *wd, short vec, short ks, short kc)
{
	if ((kc & 0x007f) == 0x0011)
		windial_longjmp(wd, vec);
	return 0;
}

long
newmsg(WINDIAL *wd, short vec, short *msg)
{
	if (msg[0] == AP_TERM)
		windial_longjmp(wd, vec);

	return 0;
}

static void
do_window(WINDIAL *wd)
{
	OBJECT *ob = wd->wb_treeptr;
	char prev = '1';
	short fd;
	long r;

	ob[X400].ob_state &= ~OS_SELECTED;
	ob[X480].ob_state &= ~OS_SELECTED;
	ob[X496].ob_state &= ~OS_SELECTED;

	fd = Fopen("u:/boot/smboost.inf", 0);
	if (fd >= 0)
	{
		r = Fread(fd, sizeof(prev), &prev);
		Fclose(fd);
		if ((r < sizeof(prev)) || (prev < '0') || (prev > '2'))
			prev = '1';
	}

	if (prev == '0')
		ob[X400].ob_state |= OS_SELECTED;
	else if (prev == '1')
		ob[X480].ob_state |= OS_SELECTED;
	else if (prev == '2')
		ob[X496].ob_state |= OS_SELECTED;

	windial_open(wd);

	if (windial_setjmp(wd, WD_MSGVEC, newmsg))
		return;
	if (windial_setjmp(wd, WD_KEYVEC, newkey))
		return;

	for (;;)
	{
		short m;
		char choice;

		m = windial_formdo(wd);
		if (m != -1)
		{
			m &= 0x7fff;
			deselect(wd, m);
		} else
			m = CANCEL;

		switch(m)
		{
			case	CANCEL:
			{
				windial_close(wd);
				return;
			}
			case	OK:
			{
				if (ob[X400].ob_state & OS_SELECTED)
					choice = '0';
				if (ob[X480].ob_state & OS_SELECTED)
					choice = '1';
				if (ob[X496].ob_state & OS_SELECTED)
					choice = '2';
				fd = Fcreate("u:/boot/smboost.inf", 0);
				if (fd > 0)
				{
					r = Fwrite(fd, sizeof(choice), &choice);
					Fclose(fd);
				}
				windial_close(wd);
				if ((fd > 0) && (choice != prev))
					windial_alert(1, MUSTRESTART);
				return;
			}
		}
	}

}

int
main(void)
{
	WINDIAL *wd;
	long r;

	r = appl_open("smconfig.rsc", 0, (char *)PNAME);
	if (r < 0)
		return r;

	wd = (WINDIAL *)windial_create(0, WINDOW, 0, 0, (char *)WNAME);

	do_window(wd);

	windial_delete(wd);

	return appl_close();
}

/* EOF */
