/* SM 124 booster: 640x480 on SM124
 *
 * (c) 2001 Draco/YC
 *
 */

/*  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

# include <string.h>
# include <mintbind.h>
# include <falcon.h>

struct xr
{
	long pixels;		/* number of pixels per line */
	long vert_lines;	/* number of horizontal lines */
	short vft_init;		/* vertical frequency timer */
	short vdb_off;		/* vertical display begin */
};

struct xr mode[3] =
{
	{ 640, 400, 0x03e7, 0x0043 },
	{ 640, 480, 0x0415, 0x0003 },
	{ 640, 496, 0x0419, 0x0001 }
};

/* Calculated screen parameters */

short cm = 1;			/* Default mode */
short text_rows;
long scr_size;

/* Timings */
short vde_off;

extern short *linea(void);
extern void setup(void);

static void
load_inf(void)
{
	short fd;
	char code = -1;
	long r;

	fd = Fopen("\\smboost.inf", 0);
	if (fd < 0)
		return;
	r = Fread(fd, sizeof(code), &code);
	Fclose(fd);

	if (r < sizeof(code))
		return;
	if (code < 0x30 || code > 0x32)
		return;

	cm = code & 0x03;
}

static inline long
get_vdo(void)
{
	long *jar = (long *)Setexc(0x05a0L>>2,-1L);

	if (jar)
	{
		while(jar[0])
		{
			if (jar[0] == 0x5f56444fL)
				return jar[1];
			jar += 2;
		}
	}

	return -1L;
}

static void
set_videl(void)
{
	*(short *)0xffff82a2L = mode[cm].vft_init;
	*(short *)0xffff82a8L = mode[cm].vdb_off;
	*(short *)0xffff82aaL = vde_off;
}

int
main(void)
{
	long oldbase, new_base, scr_temp;
	short *ln;

	load_inf();

	if (!cm)
		return 0;

	text_rows = mode[cm].vert_lines >> 4;
	vde_off = (mode[cm].vert_lines << 1) + mode[cm].vdb_off;
	scr_size = mode[cm].vert_lines * (mode[cm].pixels >> 3);
	scr_temp = Malloc(scr_size);
	bzero((char *)scr_temp, scr_size);

	if ((get_vdo() != 0x00030000L) || (short)Vgetmonitor())
		return 0;

	oldbase = (long)Physbase();

	if (!oldbase || (oldbase >= 0x00e00000L))
		return 0;

	Cconws("-- SMBooster,  2001 Draco/YC --\r\n\r\n");

	memcpy((char *)scr_temp, (char *)oldbase, 32000L);

	new_base = Srealloc(scr_size);

	if (new_base <= 0)
		return Mfree(scr_temp);

	Setscreen(new_base, new_base, -1);

	ln = linea();

	ln[-345] = mode[cm].vert_lines-1;
	ln[-21] = text_rows-1;
	ln[-2] = mode[cm].vert_lines;
	ln[31] = mode[cm].vert_lines-1;

	memcpy((char *)new_base, (char *)scr_temp, scr_size);

	Supexec(set_videl);

	Mfree(scr_temp);

	setup();	/* never returns */

	return 0;
}

/* EOF */
